var urlMemoNs = {};
urlMemoNs.urlMemo={
	x: null,
	y: null,
	window: null,
	delflg: false,

	deleteUrl: function(pElm){
		let Cc=Components.classes;
		let Ci=Components.interfaces;
		window.openDialog(
			"chrome://urlmemo/content/caution.xul",
			"caution",
			"chrome,centerscreen,modal,dialog"
		);
		if(true==this.delflg){
			let parentElm=pElm.parentNode;

			// DB Open
			let file=Cc["@mozilla.org/file/directory_service;1"]
				.getService(Ci.nsIProperties)
				.get("ProfD", Ci.nsIFile);
			file.append("urlmemo.sqlite");
			let storageService=Cc["@mozilla.org/storage/service;1"]
				.getService(Ci.mozIStorageService);
			let mDBConn=storageService.openDatabase(file);

			let statement=mDBConn.createStatement(
				"DELETE FROM urllist WHERE url=?1"
			);
			statement.bindUTF8StringParameter(0,pElm.getAttribute('href'));
			statement.execute();
			statement.reset();

			this.eraceRUrl(parentElm.getAttribute('value'));
			this.insertRemoveUrl(mDBConn,statement,parentElm.getAttribute('value'));

			let dispParentElm=document.getElementById('urlMemo'+parentElm.getAttribute('value'));
			this.eraceUrl(dispParentElm.getAttribute('value'));
			this.insertUrl(mDBConn,statement,dispParentElm.getAttribute('value'));
			statement.finalize();
		}
	},

	procUrl: function(e,pElm){
		let url=pElm.getAttribute('href');
		gBrowser.contentWindow.location.href=url;
	},

	getTitle: function(pUrl,pTitle){
		let req=new XMLHttpRequest();
		req.open('GET', pUrl,false);
		req.send(null);
		if ('text/html'==req.getResponseHeader('Content-Type')
			.substring(0,9).toLowerCase()){
			let tmp=req.responseText;
			let top=tmp.toLowerCase().search('<title>')+7;
			let end=tmp.toLowerCase().search('</title>')
			return tmp.substring(top,end);
		} else {
			return pTitle;
		}
	},

	envSet: function(){
		let url;
		let title;

		let elem=gBrowser.contentDocument.elementFromPoint(this.x,this.y);
		let elmName=elem.tagName.toLowerCase();
		if('a'==elmName){
			url=gContextMenu.getLinkURL();
			title = this.getTitle(url,gBrowser.contentDocument.title);
		}
		else if(('img'==elmName)&&('a'==elem.parentNode.tagName.toLowerCase()))
		{
			url=gContextMenu.getLinkURL();
			title = this.getTitle(url,gBrowser.contentDocument.title);
		} else {
			url=gBrowser.contentWindow.location.href;
			title=gBrowser.contentDocument.title;
		}
		return [url,title];
	},

	dbInit: function(){
		let Cc=Components.classes;
		let Ci=Components.interfaces;
		let ios;
		let fileHandler;
		let src;
		let dest;

		let file=Cc["@mozilla.org/file/directory_service;1"]
			.getService(Ci.nsIProperties)
			.get("ProfD",Ci.nsIFile);
		file.append("urlmemo.sqlite");
		let storageService=Cc["@mozilla.org/storage/service;1"]
			.getService(Ci.mozIStorageService);
		let mDBConn=storageService.openDatabase(file);
		mDBConn.executeSimpleSQL("CREATE TABLE \"urllist\" (\"url\" TEXT PRIMARY KEY  NOT NULL,\"menuNo\" INT,\"title\" TEXT )");
		return;
	},

	eraceUrl: function(pItemNo){
		let ercId='urlMemo'+pItemNo.toString();
		let parentElm=document.getElementById(ercId);
		let len=parentElm.childNodes.length;
		for(let i=0;i<len;i++)
			parentElm.removeChild(parentElm.childNodes.item(0));
	},

	eraceRUrl: function(pItemNo){
		let ercId='urlMemo_r'+pItemNo.toString();
		let parentElm=document.getElementById(ercId);
		let len=parentElm.childNodes.length;
		for(let i=0;i<len;i++)
			parentElm.removeChild(parentElm.childNodes.item(0));
	},

	insertUrl: function(pDBComm,pStatement,pItemNo){
		let item;
		let insId;
		let insPoint;

		pStatement=pDBComm.createStatement("SELECT url,title FROM urllist WHERE menuNo=?1 ORDER BY menuNo,title,url");
		pStatement.bindInt32Parameter(0,pItemNo);
		while(pStatement.executeStep()){
			item=urlMemoNs.urlMemo.createItem(
				pStatement.getUTF8String(1),
				pStatement.getUTF8String(0)
			);
			insId='urlMemo'+pItemNo.toString();
			insPoint=document.getElementById(insId);
			insPoint.appendChild(item);
		}
		pStatement.reset();
	},

	insertRemoveUrl: function(pDBComm,pStatement,pItemNo){
		let item;
		let insId;
		let insPoint;

		pStatement=pDBComm.createStatement("SELECT url,title FROM urllist WHERE menuNo=?1 ORDER BY menuNo,title,url");
		pStatement.bindInt32Parameter(0,pItemNo);
		while(pStatement.executeStep()){
			item=urlMemoNs.urlMemo.createRemoveItem(
				pStatement.getUTF8String(1),
				pStatement.getUTF8String(0)
			);
			insId='urlMemo_r'+pItemNo.toString();
			insPoint=document.getElementById(insId);
			insPoint.appendChild(item);
		}
		pStatement.reset();
	},

	registUrlDB: function(pElm){
		let Cc=Components.classes;
		let Ci=Components.interfaces;
		this.window=gBrowser.contentWindow;
		let env=this.envSet();
		let file=Cc["@mozilla.org/file/directory_service;1"]
			.getService(Ci.nsIProperties)
			.get("ProfD", Ci.nsIFile);
		file.append("urlmemo.sqlite");
		if (!(file.exists()))
			this.dbInit();

		if ('about:blank'!=env[0]){
			// DB Open
			let file=Cc["@mozilla.org/file/directory_service;1"]
				.getService(Ci.nsIProperties)
				.get("ProfD",Ci.nsIFile);
			file.append("urlmemo.sqlite");
			let storageService=Cc["@mozilla.org/storage/service;1"]
				.getService(Ci.mozIStorageService);
			let mDBConn=storageService.openDatabase(file);

			// 重複チェック
			let cnt;
			let statement=mDBConn.createStatement(
				"SELECT count(*) FROM urllist WHERE url = ?1"
			);
			statement.bindUTF8StringParameter(0,env[0]);
			while(statement.executeStep())
				cnt=statement.getInt32(0);
			statement.reset();

			if (1>cnt){
				statement=mDBConn.createStatement(
					"INSERT INTO urllist (url,menuNo,title) VALUES (?1,?2,?3)"
				);
				statement.bindUTF8StringParameter(0,env[0]);
				statement.bindUTF8StringParameter(1,pElm.getAttribute('value'));
				statement.bindUTF8StringParameter(2,env[1]);
				statement.execute();
				statement.reset();
				this.eraceUrl(pElm.getAttribute('value'));
				this.eraceRUrl(pElm.getAttribute('value'));
				this.insertUrl(mDBConn,statement,pElm.getAttribute('value'));
				this.insertRemoveUrl(mDBConn,statement,pElm.getAttribute('value'));
			}
			statement.finalize();
		}
	},

	createItem: function(pTitle,pUri){
		let req=new XMLHttpRequest();
		req.open('GET','chrome://urlmemo/content/item.xul',false); 
		req.send(null);
		let oldNode=req.responseXML.getElementsByTagName('menuitem').item(0);
		oldNode.setAttribute('label',pTitle);
		oldNode.setAttribute('href',pUri);
		oldNode.setAttribute('tooltiptext',pUri);

		let itemElm=document.importNode(oldNode,true);
		return itemElm;
	},

	createRemoveItem: function(pTitle,pUri){
		let req=new XMLHttpRequest();
		req.open('GET','chrome://urlmemo/content/rmitem.xul',false); 
		req.send(null);
		let oldNode=req.responseXML.getElementsByTagName('menuitem').item(0);
		oldNode.setAttribute('label',pTitle);
		oldNode.setAttribute('href',pUri);
		oldNode.setAttribute('tooltiptext',pUri);

		let itemElm=document.importNode(oldNode,true);
		return itemElm;
	}
};

urlMemoNs.urlMemoComm={
	setXY: function(e)
	{
		if (e.button==2) {
			urlMemoNs.urlMemo.x = e.clientX;
			urlMemoNs.urlMemo.y = e.clientY;
		}
	},

	init: function()
	{
		let Cc=Components.classes;
		let Ci=Components.interfaces;
		let item;
		let insId;
		let insPoint;
		let ritem;
		let rinsId;
		let rinsPoint;

		let file=Cc["@mozilla.org/file/directory_service;1"]
			.getService(Ci.nsIProperties)
			.get("ProfD", Ci.nsIFile);
		file.append("urlmemo.sqlite");
		if (!(file.exists()))
			urlMemoNs.urlMemo.dbInit();

		let storageService=Cc["@mozilla.org/storage/service;1"]
			.getService(Ci.mozIStorageService);
		let mDBConn=storageService.openDatabase(file);

		let statement=mDBConn.createStatement(
			"SELECT url,menuNo,title FROM urllist ORDER BY menuNo,title,url"
		);
		while(statement.executeStep()){
			item=urlMemoNs.urlMemo.createItem(
				statement.getUTF8String(2),
				statement.getUTF8String(0)
			);
			insId='urlMemo'+statement.getInt32(1).toString();
			insPoint=document.getElementById(insId);
			insPoint.appendChild(item);
			ritem=urlMemoNs.urlMemo.createRemoveItem(
				statement.getUTF8String(2),
				statement.getUTF8String(0)
			);
			rinsId='urlMemo_r'+statement.getInt32(1).toString();
			rinsPoint=document.getElementById(rinsId);
			rinsPoint.appendChild(ritem);
		}
		statement.reset();
		statement.finalize();

		// DB close
		mDBConn.close();
	}
};
document.addEventListener('mousedown',urlMemoNs.urlMemoComm.setXY,false);
window.addEventListener('load',urlMemoNs.urlMemoComm.init,false);
